import 'package:atlassian_connect_host/src/descriptor/descriptor_model.dart';

import 'package:uri/uri.dart';
import 'dart:convert';
import 'package:constrain/constrain.dart';

main() {
  final jsonEncoder = new JsonEncoder.withIndent('  ');

  final addon = new ProductlessConnectAddon(
    key: "my-addon",
    name: "My Addon",
    modules: new CoreModuleList(
      webItems: [
        new WebItem(
          key: 'my-webitem',
          name: new I18nProperty(
              value: 'My Web Item'
          ),
          urlStr: '/foo?projectid={project.id}',
          location: 'system.top.navigation.bar')
      ]
    )
  );

  print(addon.toJson());
  print(jsonEncoder.convert(addon));

  final validator = new Validator();
  final violations = validator.validate(addon);
  violations.forEach((v) => print(v.verboseMessage));
  print(addon.modules.webItems.first.url.expand({'project.id': '334'}));
//  print(violations);
}